## ardour3 3.4~dfsg

=== wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import string
import subprocess
import sys

MAJOR = '3'
MINOR = '4'
VERSION = MAJOR + '.' + MINOR

APPNAME = 'Ardour' + MAJOR

# Mandatory variables
top = '.'
out = 'build'

children = [
        'libs/pbd',
        'libs/midi++2',
        'libs/evoral',
        'libs/vamp-sdk',
        'libs/qm-dsp',
        'libs/vamp-plugins',
        'libs/taglib',
        'libs/libltc',
        'libs/rubberband',
        'libs/surfaces',
        'libs/panners',
        'libs/timecode',
        'libs/ardour',
        'libs/gtkmm2ext',
        'libs/clearlooks-newer',
        'libs/audiographer',
        'gtk2_ardour',
        'export',
        'midi_maps',
        'mcp',
        'patchfiles'
]

i18n_children = [
        'gtk2_ardour',
        'libs/ardour',
        'libs/gtkmm2ext',
]

if sys.platform == 'linux2':
    children += [ 'tools/sanity_check' ]
    lxvst_default = True
elif sys.platform == 'darwin':
    children += [ 'libs/appleutility' ]
    lxvst_default = False
else:
    lxvst_default = False

# Version stuff

def fetch_gcc_version (CC):
    cmd = "LANG= %s --version" % CC
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    o = output[0].decode('utf-8')
    version = o.split(' ')[2].split('.')
    return version

def fetch_git_revision ():
    cmd = "LANG= git describe --tags HEAD"
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    rev = output[0].decode('utf-8')
    return rev

def create_stored_revision():
    rev = ""
    if os.path.exists('.git'):
        rev = fetch_git_revision();
        print("ardour.git version: " + rev + "\n")
    elif os.path.exists('libs/ardour/revision.cc'):
        print("Using packaged revision")
        return
    else:
        print("Missing libs/ardour/revision.cc.  Blame the packager.")
        sys.exit(-1)

    try:
        text =  '#include "ardour/revision.h"\n'
        text += 'namespace ARDOUR { const char* revision = \"%s\"; }\n' % rev
        print('Writing revision info to libs/ardour/revision.cc using ' + rev)
        o = open('libs/ardour/revision.cc', 'w')
        o.write(text)
        o.close()
    except IOError:
        print('Could not open libs/ardour/revision.cc for writing\n')
        sys.exit(-1)

def set_compiler_flags (conf,opt):
    #
    # Compiler flags and other system-dependent stuff
    #

    build_host_supports_sse = False
    optimization_flags = []
    debug_flags = []

    u = os.uname ()
    cpu = u[4]
    platform = u[0].lower()
    version = u[2]

    # waf adds -O0 -g itself. thanks waf!
    is_clang = conf.env['CXX'][0].endswith('clang++')
    
    if conf.options.cxx11:
        conf.check_cxx(cxxflags=["-std=c++11"])
        conf.env.append_unique('CXXFLAGS', ['-std=c++11'])
        if platform == "darwin":
            conf.env.append_unique('CXXFLAGS', ['-stdlib=libc++'])
            conf.env.append_unique('LINKFLAGS', ['-lc++'])
            # Prevents visibility issues in standard headers
            conf.define("_DARWIN_C_SOURCE", 1)

    if is_clang and platform == "darwin":
        # Silence warnings about the non-existing osx clang compiler flags
        # -compatibility_version and -current_version.  These are Waf
        # generated and not needed with clang
        conf.env.append_unique ("CXXFLAGS", ["-Qunused-arguments"])
        
    if opt.gprofile:
        debug_flags = [ '-pg' ]

    if opt.backtrace:
        if platform != 'darwin' and not is_clang:
            debug_flags = [ '-rdynamic' ]

    # Autodetect
    if opt.dist_target == 'auto':
        if platform == 'darwin':
            # The [.] matches to the dot after the major version, "." would match any character
            if re.search ("^[0-7][.]", version) != None:
                conf.env['build_target'] = 'panther'
            elif re.search ("^8[.]", version) != None:
                conf.env['build_target'] = 'tiger'
            elif re.search ("^9[.]", version) != None:
                conf.env['build_target'] = 'leopard'
            elif re.search ("^10[.]", version) != None:
                conf.env['build_target'] = 'snowleopard'
            elif re.search ("^11[.]", version) != None:
                conf.env['build_target'] = 'lion'
            else:
                conf.env['build_target'] = 'mountainlion'
        else:
            if re.search ("x86_64", cpu) != None:
                conf.env['build_target'] = 'x86_64'
            elif re.search("i[0-5]86", cpu) != None:
                conf.env['build_target'] = 'i386'
            elif re.search("powerpc", cpu) != None:
                conf.env['build_target'] = 'powerpc'
            else:
                conf.env['build_target'] = 'i686'
    else:
        conf.env['build_target'] = opt.dist_target

    if conf.env['build_target'] == 'snowleopard':
        #
        # stupid OS X 10.6 has a bug in math.h that prevents llrint and friends
        # from being visible.
        # 
        debug_flags.append ('-U__STRICT_ANSI__')
        optimization_flags.append ('-U__STRICT_ANSI__')

    if cpu == 'powerpc' and conf.env['build_target'] != 'none':
        #
        # Apple/PowerPC optimization options
        #
        # -mcpu=7450 does not reliably work with gcc 3.*
        #
        if opt.dist_target == 'panther' or opt.dist_target == 'tiger':
            if platform == 'darwin':
                # optimization_flags.extend ([ "-mcpu=7450", "-faltivec"])
                # to support g3s but still have some optimization for above
                optimization_flags.extend ([ "-mcpu=G3", "-mtune=7450"])
            else:
                optimization_flags.extend ([ "-mcpu=7400", "-maltivec", "-mabi=altivec"])
        else:
            optimization_flags.extend([ "-mcpu=750", "-mmultiple" ])
        optimization_flags.extend (["-mhard-float", "-mpowerpc-gfxopt"])
        optimization_flags.extend (["-Os"])

    elif ((re.search ("i[0-9]86", cpu) != None) or (re.search ("x86_64", cpu) != None)) and conf.env['build_target'] != 'none':


        #
        # ARCH_X86 means anything in the x86 family from i386 to x86_64
        # the compile-time presence of the macro _LP64 is used to 
        # distingush 32 and 64 bit assembler
        #

        if (re.search ("(i[0-9]86|x86_64)", cpu) != None):
            debug_flags.append ("-DARCH_X86")
            optimization_flags.append ("-DARCH_X86")

        if platform == 'linux' :

            #
            # determine processor flags via /proc/cpuinfo
            #

            if conf.env['build_target'] != 'i386':

                flag_line = os.popen ("cat /proc/cpuinfo | grep '^flags'").read()[:-1]
                x86_flags = flag_line.split (": ")[1:][0].split ()

                if "mmx" in x86_flags:
                    optimization_flags.append ("-mmmx")
                if "sse" in x86_flags:
                    build_host_supports_sse = True
                if "3dnow" in x86_flags:
                    optimization_flags.append ("-m3dnow")

            if cpu == "i586":
                optimization_flags.append ("-march=i586")
            elif cpu == "i686":
                optimization_flags.append ("-march=i686")

        if not is_clang and ((conf.env['build_target'] == 'i686') or (conf.env['build_target'] == 'x86_64')) and build_host_supports_sse:
            optimization_flags.extend (["-msse", "-mfpmath=sse", "-DUSE_XMMINTRIN"])
            debug_flags.extend (["-msse", "-mfpmath=sse", "-DUSE_XMMINTRIN"])

    # end of processor-specific section

    # optimization section
    if conf.env['FPU_OPTIMIZATION']:
        if sys.platform == 'darwin':
            optimization_flags.append ("-DBUILD_VECLIB_OPTIMIZATIONS");
            debug_flags.append ("-DBUILD_VECLIB_OPTIMIZATIONS");
            conf.env.append_value('LINKFLAGS', "-framework Accelerate")
        elif conf.env['build_target'] == 'i686' or conf.env['build_target'] == 'x86_64':
            optimization_flags.append ("-DBUILD_SSE_OPTIMIZATIONS")
            debug_flags.append ("-DBUILD_SSE_OPTIMIZATIONS")
        if not build_host_supports_sse:
            print("\nWarning: you are building Ardour with SSE support even though your system does not support these instructions. (This may not be an error, especially if you are a package maintainer)")

    # end optimization section

    #
    # no VST on x86_64
    #

    if conf.env['build_target'] == 'x86_64' and opt.windows_vst:
        print("\n\n==================================================")
        print("You cannot use VST plugins with a 64 bit host. Please run waf with --windows-vst=0")
        print("\nIt is theoretically possible to build a 32 bit host on a 64 bit system.")
        print("However, this is tricky and not recommended for beginners.")
        sys.exit (-1)

    if opt.lxvst:
        if conf.env['build_target'] == 'x86_64':
            conf.env.append_value('CXXFLAGS', "-DLXVST_64BIT")
        else:
            conf.env.append_value('CXXFLAGS', "-DLXVST_32BIT")

    #
    # a single way to test if we're on OS X
    #

    if conf.env['build_target'] in ['panther', 'tiger', 'leopard', 'snowleopard' ]:
        conf.define ('IS_OSX', 1)
        # force tiger or later, to avoid issues on PPC which defaults
        # back to 10.1 if we don't tell it otherwise.
        
        conf.env.append_value('CFLAGS', "-DMAC_OS_X_VERSION_MIN_REQUIRED=1040")
        conf.env.append_value('CXXFLAGS', "-DMAC_OS_X_VERSION_MIN_REQUIRED=1040")
        conf.env.append_value('CXXFLAGS', '-mmacosx-version-min=10.4')
        conf.env.append_value('CFLAGS', '-mmacosx-version-min=10.4')


    elif conf.env['build_target'] in [ 'lion', 'mountainlion' ]:
        conf.env.append_value('CFLAGS', "-DMAC_OS_X_VERSION_MIN_REQUIRED=1070")
        conf.env.append_value('CXXFLAGS', "-DMAC_OS_X_VERSION_MIN_REQUIRED=1070")
        conf.env.append_value('CXXFLAGS', '-mmacosx-version-min=10.7')
        conf.env.append_value('CFLAGS', '-mmacosx-version-min=10.7')
    else:
        conf.define ('IS_OSX', 0)

    #
    # save off CPU element in an env
    #
    conf.define ('CONFIG_ARCH', cpu)

    #
    # ARCH="..." overrides all
    #

    if opt.arch != None:
        optimization_flags = opt.arch.split()

    #
    # prepend boiler plate optimization flags that work on all architectures
    #

    optimization_flags[:0] = [
            "-O3",
            "-fomit-frame-pointer",
            "-ffast-math",
            "-fstrength-reduce",
            "-pipe"
            ]

    if opt.debug:
        conf.env.append_value('CFLAGS', debug_flags)
        conf.env.append_value('CXXFLAGS', debug_flags)
        conf.env.append_value('LINKFLAGS', debug_flags)
    else:
        conf.env.append_value('CFLAGS', optimization_flags)
        conf.env.append_value('CXXFLAGS', optimization_flags)
        conf.env.append_value('LINKFLAGS', optimization_flags)

    if opt.stl_debug:
        conf.env.append_value('CXXFLAGS', "-D_GLIBCXX_DEBUG")

    if conf.env['DEBUG_RT_ALLOC']:
        conf.env.append_value('CFLAGS', '-DDEBUG_RT_ALLOC')
        conf.env.append_value('CXXFLAGS', '-DDEBUG_RT_ALLOC')
        conf.env.append_value('LINKFLAGS', '-ldl')

    if conf.env['DEBUG_DENORMAL_EXCEPTION']:
        conf.env.append_value('CFLAGS', '-DDEBUG_DENORMAL_EXCEPTION')
        conf.env.append_value('CXXFLAGS', '-DDEBUG_DENORMAL_EXCEPTION')

    if opt.universal:
        if opt.generic:
            print ('Specifying Universal and Generic builds at the same time is not supported')
            sys.exit (1)
        else:
            if not Options.options.nocarbon:
                conf.env.append_value('CFLAGS', ["-arch", "i386", "-arch", "ppc"])
                conf.env.append_value('CXXFLAGS', ["-arch", "i386", "-arch", "ppc"])
