=== libs/rubberband/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os
import glob

# Version of this package (even if built as a child)
LIBRUBBERBAND_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBRUBBERBAND_LIB_VERSION = '4.1.0'

# Variables for 'waf dist'
APPNAME = 'librubberband'
VERSION = LIBRUBBERBAND_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)

def build(bld):
    # Library
    obj = bld(features = 'cxx cxxshlib')
    prefix = 'libs/rubberband/'
    sources = glob.glob(prefix + 'src/*.cpp')
    obj.source = [ ]
    for i in sources:
        obj.source += [ i.replace(prefix, '') ]
    obj.export_includes = ['.']
    obj.includes     = ['.', 'rubberband']
    obj.name         = 'librubberband'
    obj.target       = 'rubberband'
    obj.uselib       = 'FFTW3 FFTW3F SAMPLERATE SNDFILE'
    obj.use          = 'libvamphost'
    obj.vnum         = LIBRUBBERBAND_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')
    obj.cxxflags     = '-DPACKAGE="librubberband"'

def shutdown():
    autowaf.shutdown()
