=== debian/changelog ===
ardour3 (3.4~dfsg-3ubuntu1) saucy; urgency=low

  * Cherry-pick from Debian:
    +  Build for i686 instead of i386 to enable SSE

 -- Iain Lane <iain@orangesquash.org.uk>  Sat, 05 Oct 2013 11:49:27 +0100

ardour3 (3.4~dfsg-3) unstable; urgency=low

  [ Felipe Sateler ]
  * Build translations (Closes: #724315)
  * configure: set --dist-target parameter (Closes: #724526)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Fri, 04 Oct 2013 18:46:35 +0200

ardour3 (3.4~dfsg-2) unstable; urgency=low

  * Team upload.

  [ Felipe Sateler ]
  * Re-upload to unstable

  [ Jaromír Mikeš ]
  * Update copyright file.

 -- Felipe Sateler <fsateler@debian.org>  Sat, 21 Sep 2013 19:05:02 -0300

ardour3 (3.4~dfsg-1) unstable; urgency=low

  * Team upload.
  [ Adrian Knoth ]
  * Initial release. (Closes: #623339 #622634 #717277)
  * Improve debian/copyright
  * Imported Upstream version 3.4~dfsg
    - Drop patches not relevant to ardour3

  [ Jaromír Mikeš ]
  * Create xmp icon fron png one.
  * Fix desktop and menu files.

  [ Felipe Sateler ]
  * Remove obsolete ardour3-{flavour} files, we don't have flavors anymore
  * Remove obsolete series.disabled file

 -- Felipe Sateler <fsateler@debian.org>  Mon, 16 Sep 2013 13:20:44 -0300
